# Execute an invoice schedule Executes an invoice schedule immediately. During the execution, a bill run is created and generates an invoice or a credit memo asynchronously. When you use this API operation to execute an invoice schedule item, you have the flexibility to decide whether to specify a specific item ID. - If you specify the unique ID of an invoice schedule item to be executed in the request, the corresponding invoice schedule item is executed. - If you do not specify the ID of any invoice schedule item in the request, the subscription end date is used as the target date to determine the next pending schedule item to be executed. A paused invoice schedule and charges inside cannot be automatically executed by Zuora Scheduler or by this "Execute an invoice schedule" API operation. In this case, you can do one of the following: - Use the Generate billing documents by account ID API operation - Create a bill run with the target date greater than the next run date of the invoice schedule through UI or API For more samples, see Execute invoice schedules. Note: This operation is available only if you have the Billing Schedule feature enabled. Endpoint: POST /v1/invoice-schedules/{scheduleKey}/execute Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Path parameters: - `scheduleKey` (string, required) The unique ID or number of the schedule to be executed. For example, 2c92c8955bd63cc1015bd7c151af02ab or IS-0000001. ## Request fields (application/json): - `scheduleItemId` (string) The ID of the invoice schedule item to be executed. The item must be the earliest pending schedule item. If all the invoice schedule items have been processed and credit is needed to be generated, do not specify this field in the request. Example: "8ad09b7d82b5c62f0182c5cd16944f73" ## Response 200 fields (application/json): - `autoEmail` (boolean) Whether to automatically send an email after Auto-Post is complete. - `autoPost` (boolean) Whether to automatically post the bill run after the bill run is created. - `autoRenewal` (boolean) Whether to automatically renew auto-renew subscriptions that are up for renewal. - `batches` (array) A list of the batches of accounts for this bill run. This field cannot exist with the billRunFilters field. Values: AllBatches or Batchn where n is a number between 1 and 50, for example, Batch7. - `billCycleDay` (string) The day of the bill cycle, this field is only valid when batches is specified. Values: - AllBillCycleDays or 1 - 31 for an ad-hoc bill run - AllBillCycleDays or 1 - 31 or AsRunDay for a scheduled bill run - `billRunFilters` (array) A list of the target account or subscriptions for this bill run. This field cannot exist with the batches field. Example: [{"accountId":"2c9081a03c63c94c013c66688a2c00bf","filterType":"Subscription","subscriptionId":"402882297e387c51017e38a245c313db"}] - `billRunFilters.accountId` (string) The target account of the bill run. - `billRunFilters.filterType` (string) The type of the filter to determine whether to create a bill run at the account level or subscription level. Enum: "Account", "Subscription", "InvoiceSchedule" - `billRunFilters.subscriptionId` (string) The unique ID of the target subscription belonged to the target account. This field is required if you set the filterType field to Subscription. - `billRunNumber` (string) The number of bill run. Example: "BR-00000016" - `chargeTypeToExclude` (array) The types of the charges to be excluded from the generation of billing documents. Enum: "OneTime", "Recurring", "Usage" - `createdById` (string) The ID of the user who created the bill run. Example: "ff808081298c6e5401298c7274a40005" - `createdDate` (string) The date and time when the bill run was created. Example: "2022-01-24 19:58:27" - `id` (string) The unique ID of the bill run. Example: "2c9890077e8a8490017e8bf3a5171a43" - `invoiceDate` (string) The invoice date for this bill run, only valid for ad-hoc bill runs. Example: "2020-02-01" - `invoiceDateOffset` (integer) The offset compared to bill run execution date, only valid for scheduled bill runs. - `noEmailForZeroAmountInvoice` (boolean) Whether to suppress emails for invoices with the total amount of zero or not for this bill run after the bill run is complete. Note: Do not email invoices with the total amount of zero. - `organizationLabels` (array) The organization(s) that the object belongs to. Note: This field is available only when the Multi-Org feature is enabled. - `organizationLabels.organizationId` (string) The organization ID. - `organizationLabels.organizationName` (string) The organization name. - `scheduledExecutionTime` (string) The scheduled execution time for a bill run. - `status` (string) The status of the bill run. Enum: "Pending", "Processing", "Completed", "Error", "Canceled", "Posted", "PostInProgress", "CancelInProgress", "RemoveInProgress", "Paused" - `targetDate` (string) The target date for this bill run, only valid for ad-hoc bill run. Example: "2020-02-01" - `targetDateOffset` (integer) The offset compared to bill run execution date, only valid for scheduled bill run. - `updatedById` (string) The ID of the user who updated the bill run. Example: "ff808081298c6e5401298c7274a40005" - `updatedDate` (string) The date and time when the bill run was updated. Example: "2022-01-24 19:58:27" ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.